--
-- loadFromTrailer

-- Specialization for loading a shovel from a trailer, e.g. for supplying seeding machines.

-- upsideDown 05.05.2013

loadFromTrailer = {};



function loadFromTrailer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Shovel, specializations) and SpecializationUtil.hasSpecialization(Fillable, specializations);
	-- return SpecializationUtil.hasSpecialization(Fillable, specializations);
	--return true
end;

function loadFromTrailer:load(xmlFile)
	self.LFTfindTrailerRaycastCallback = loadFromTrailer.LFTfindTrailerRaycastCallback;
	self.LFToverCharge = false;
	self.LFTdoDraw = false;
end;

function loadFromTrailer:delete()

end;

function loadFromTrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function loadFromTrailer:keyEvent(unicode, sym, modifier, isDown)
 
end;

function loadFromTrailer:readStream(streamId, connection)
    
end;
  
function loadFromTrailer:writeStream(streamId, connection)
    
end;

function loadFromTrailer:update(dt)

      if self:getIsActiveForInput() then
		--if self.LFTtrailerFound ~= nil and self.LFTtrailerFound ~= 0 then
		if self.LFTdoDraw then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
				self.LFToverCharge = not self.LFToverCharge;
			end;
		end
     end;

end;

function loadFromTrailer:updateTick(dt)
		

    if self:getIsActive() then
		self.LFTtrailerFound = nil;
	
		local x, y, z = getWorldTranslation(self.rootNode);
		local dx, dy, dz = localDirectionToWorld(self.rootNode, 0, 0.3, 1);
		raycastAll(x, y, z, dx, dy, dz, "LFTfindTrailerRaycastCallback", 3, self);
		
		self.LFTdoDraw = false;
		if self.LFTtrailerFound ~= nil and self.LFTtrailerFound ~= 0  then
			local trailer = g_currentMission.nodeToVehicle[self.LFTtrailerFound];
			if self.currentFillType == FruitUtil.FRUITTYPE_UNKNOWN or (self.currentFillType == trailer.currentFillType) then				
				if trailer ~= nil and self:allowFillType(trailer.currentFillType, true) and self.capacity ~= self.fillLevel and trailer.fillLevel > 0 then
					self.LFTdoDraw = true;
					if self.LFToverCharge then
						local delta = .1 * dt;
						if trailer.fillLevel < delta then
							delta = trailer.fillLevel;
						end
						if self.fillLevel + delta > self.capacity then
							delta = self.capacity - self.fillLevel
						end
						self:setFillLevel(self.fillLevel + delta,trailer.currentFillType)
						trailer:setFillLevel(trailer.fillLevel - delta,trailer.currentFillType)
					end
				else
					self.LFToverCharge = false;
				end
			else
				self.LFToverCharge = false;
			end
		else
			self.LFToverCharge = false;
		end

		
	end;
end;

function loadFromTrailer:LFTfindTrailerRaycastCallback(transformId, x, y, z, distance)
	local trailer = g_currentMission.nodeToVehicle[transformId];
	if trailer ~= nil and trailer ~= self then
		if trailer.exactFillRootNode == transformId  then
			self.LFTtrailerFound = transformId;
			return false;
		end;
	end;
	return true;
end;

function loadFromTrailer:draw()

	if self.LFTdoDraw then
		if self.LFToverCharge then
			g_currentMission:addHelpButtonText("stop loading from trailer", InputBinding.IMPLEMENT_EXTRA3);
		else
			g_currentMission:addHelpButtonText("start loading from trailer", InputBinding.IMPLEMENT_EXTRA3);
		end
	end
	--g_currentMission:addExtraPrintText("   ");	
	--g_currentMission:addHelpButtonText(g_i18n:getText("LowerBucket"), InputBinding.IMPLEMENT_EXTRA2);
	
end;

function loadFromTrailer:onDetach()

end;